---
title: "palopoli-marchetti-2020-dev"
author: "Palopoli Nicolas - Marchetti Julia"
date: "7/24/2020"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Load packages
```{r loading-packages, message=FALSE, warning=FALSE}
library(tidyverse)
library(ggplot2)
library(ggpubr)
library(readxl)
library(patchwork)
library(ggThemeAssist)
library(ggtext)
```

# Loading Functions: 
- g function: tu calculate mode 
```{r g-function-to-get-mode, include=FALSE}
g <- function(number) {
  ux <- unique(number)
  ux[which.max(tabulate(match(number, ux)))]
}
```
- multiplot function 
```{r multiplot-function, include=FALSE}
# Multiple plot function
#
# ggplot objects can be passed in ..., or to plotlist (as a list of ggplot objects)
# - cols:   Number of columns in layout
# - layout: A matrix specifying the layout. If present, 'cols' is ignored.
#
# If the layout is something like matrix(c(1,2,3,3), nrow=2, byrow=TRUE),
# then plot 1 will go in the upper left, 2 will go in the upper right, and
# 3 will go all the way across the bottom.
#
multiplot <- function(..., plotlist=NULL, file, cols=1, layout=NULL) {
  library(grid)

  # Make a list from the ... arguments and plotlist
  plots <- c(list(...), plotlist)

  numPlots = length(plots)

  # If layout is NULL, then use 'cols' to determine layout
  if (is.null(layout)) {
    # Make the panel
    # ncol: Number of columns of plots
    # nrow: Number of rows needed, calculated from # of cols
    layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
                    ncol = cols, nrow = ceiling(numPlots/cols))
  }

 if (numPlots==1) {
    print(plots[[1]])

  } else {
    # Set up the page
    grid.newpage()
    pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout))))

    # Make each plot, in the correct location
    for (i in 1:numPlots) {
      # Get the i,j matrix positions of the regions that contain this subplot
      matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))

      print(plots[[i]], vp = viewport(layout.pos.row = matchidx$row,
                                      layout.pos.col = matchidx$col))
    }
  }
}
```



# Loading data

Load Rate df for globular and disorder proteins 
```{r load-data, message=FALSE}
#Load table with visual check
fig1_final_visual_check <- read_csv("../data/fig1_dis_final_gus_20_4_visual.csv")
```


Load disorder regions df 
```{r load-disorder-region-data, message=FALSE, warning=FALSE}
distance_from_order_df <- read_csv("../data/distance_from_order.csv") 
```

Load data of RMSF 
```{r rmsf-df,  message=FALSE, warning=FALSE}
all_rmsf <- read_csv('../data/all_rmsf.csv')
```

Load data of correlations
```{r load-corr_data-df, message=FALSE, warning=FALSE}
corr_data <- read_csv('../data/corr_data.csv')
```

```{r read-contact-matriz, message=FALSE, warning=FALSE}
contact_matrix <- read_csv("~/Documents/SBG/marchetti-palopoli-2020-dev/data/matriz_parseada.csv")
```

# Data manipulation

## Working on rmsf_df 
- Add position column in a sequential manner to RMSF df 
- rmsd_ave column: rmsf average for a protein
```{r add-column-of-position-in-sequential-manner}
all_rmsf<-all_rmsf %>%
  group_by(pdb_chain) %>% 
  mutate(position = row_number()) %>% 
  mutate(rmsf_ave = mean(rmsf)) %>% 
  mutate(rmsf_norm = rmsf/rmsf_ave)
```

## Working on rate df 
- Remove chimera proteins
```{r del-chimera-on-rate-df}
remove_pdb<- c('1pn5A','2kuqA', '2mf9A', '2yt2A', '1mv3A')
fig1_final_visual_check<-fig1_final_visual_check[!fig1_final_visual_check$pdb_chain %in% remove_pdb, ]
```

- filter in order to keep with those pdbchain with visual_check=1.
```{r filter-visual-check-positive-rate-df }
fig1_final_visual_check_final <- fig1_final_visual_check %>% 
  filter(visual_check==1)
```

- Remove all df rate that are not used any longer 
```{r delete-rates-df}
rm(fig1_final_visual_check)
```


- Add structure column  (factor) and contact-site column (1 or 0) 
```{r creation-structure-column}
fig1_final_visual_check_final <- fig1_final_visual_check_final %>% 
  mutate(structure=as.factor(paste(dataset, is_disorder_es,sep='-'))) %>% 
  mutate(contact_site=ifelse(contacts >= 1,1,0))
levels(fig1_final_visual_check_final$structure)[levels(fig1_final_visual_check_final$structure)=="disorder-1"] <- "disorder(dis)"
levels(fig1_final_visual_check_final$structure)[levels(fig1_final_visual_check_final$structure)=="disorder-0"] <- "disorder(ord)"
levels(fig1_final_visual_check_final$structure)[levels(fig1_final_visual_check_final$structure)=="order-1"] <- "order"
levels(fig1_final_visual_check_final$structure)[levels(fig1_final_visual_check_final$structure)=="order-0"] <- "order"

```

- Add a second structure column
```{r new-structure-col-in-fig1-df}
fig1_final_visual_check_final<-fig1_final_visual_check_final %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order'))
```


- Add contact column (factor)
```{r column-contact-factor}
fig1_final_visual_check_final$contact_factor <-as_factor(fig1_final_visual_check_final$contacts)

contacts_to_group <-c(7,8,9,10,11,12,13,14)
for (i in contacts_to_group){
  levels(fig1_final_visual_check_final$contact_factor)[levels(fig1_final_visual_check_final$contact_factor)==i] <- ">=7"
}
```

- Add  column of position normalized by lenght of protein: round up to 1 (position_length) or  significant numbers (position_length_sig2)
```{r position_lenght_column}
fig1_final_visual_check_final <- fig1_final_visual_check_final %>% 
  group_by(pdb_chain,dataset,model) %>% 
  mutate(protein_length=n()) %>% 
  ungroup() %>% 
  mutate(position_length = (round(position/protein_length,1))) %>% 
  mutate(position_length_sig2 = (signif(position/protein_length,2)))
```


- Joining df of RMSF and rate info
```{r joning-RMSF-fig1}
fig1_final_visual_check_final<-left_join(fig1_final_visual_check_final, all_rmsf)
```


- Add column that contains the average for the rate and rmsf based on the two normalized positions
```{r mean-rate-rmsf-by-position-lenght-column}
fig1_final_visual_check_final <- fig1_final_visual_check_final %>% 
  group_by(pdb_chain,dataset,position_length) %>% 
  mutate(rmsf_avg_pos = mean(rmsf), rate_avg_pos = mean(normperprot)) %>% 
  ungroup() %>% 
  group_by(pdb_chain,dataset,position_length_sig2) %>% 
  mutate(rmsf_avg_pos_sig2 = mean(rmsf), rate_avg_pos_sig2 = mean(normperprot)) %>%
  ungroup()
```



## Creation of a contact information df 
- This df contains different descriptors regarding contacts by position along each ensemble such as: mean, mode, max, min and contact_permanence (named in the manuscript as contact robustness or contact fraction)
- Delete columns that will not longer be used 
Create df of contact info that MUST have 38737 rows
```{r conf-min-mean-mode-permanence-contacts, message=FALSE }
fig1_final_visual_check_final_contact_info <- fig1_final_visual_check_final %>%
  group_by(pdb_chain, position, dataset) %>%
  mutate( number_conf = n(), 
             contact_site_ensemble=sum(contact_site),
             mean_contacts=mean(contacts),
             min_contacts = min(contacts),
             max_contacts = max(contacts),
             mode_contacts = g(contacts)) %>% 
  mutate(diff_max_min = abs(min_contacts-max_contacts)) %>% 
  mutate(contact_permanence = (contact_site_ensemble/number_conf)*100) %>% 
  ungroup()
cols_to_remove <-c("r4sB", "contacts","r4s_bayes_normavg","r4s_ml_normavg","posname","raw",'model','contact_factor','contact_site')
fig1_final_visual_check_final_contact_info <- fig1_final_visual_check_final_contact_info %>% 
  select(-c(cols_to_remove)) %>% 
  distinct()
```


- Add contact permanence factor column on contact information df 

```{r contact-permanence-factor-column}

fig1_final_visual_check_final_contact_info <- fig1_final_visual_check_final_contact_info %>% 
  mutate(bin_permanence_factor= case_when(
                   contact_permanence == 0 | contact_permanence < 10 ~ "[0-10)",
                   contact_permanence >= 10 & contact_permanence < 20 ~ "[10-20)",
                   contact_permanence >= 20 & contact_permanence < 30 ~ "[20-30)",
                   contact_permanence >= 30 & contact_permanence < 40 ~ "[30-40)",
                   contact_permanence >= 40 & contact_permanence < 50 ~ "[40-50)",
                   contact_permanence >= 50 & contact_permanence < 60 ~ "[50-60)",
                   contact_permanence >= 60 & contact_permanence < 70 ~ "[60-70)",
                   contact_permanence >= 70 & contact_permanence < 80 ~ "[70-80)",
                   contact_permanence >= 80 & contact_permanence < 90 ~ "[80-90)",
                   contact_permanence >= 90 & contact_permanence <= 100 ~ "[90-100]")) %>% 
  mutate(bin_permanence_factor = as.factor(bin_permanence_factor))
levels(as.factor(fig1_final_visual_check_final_contact_info$bin_permanence_factor))

```

```{r add-second-column-of-permance}
fig1_final_visual_check_final_contact_info <- fig1_final_visual_check_final_contact_info %>% 
  mutate(contact_permanence_2= case_when(
                  contact_permanence == 0  ~ "[0]",
                   contact_permanence > 0 & contact_permanence < 10 ~ "[0-10)",
                   contact_permanence >= 10 & contact_permanence < 20 ~ "[10-20)",
                   contact_permanence >= 20 & contact_permanence < 30 ~ "[20-30)",
                   contact_permanence >= 30 & contact_permanence < 40 ~ "[30-40)",
                   contact_permanence >= 40 & contact_permanence < 50 ~ "[40-50)",
                   contact_permanence >= 50 & contact_permanence < 60 ~ "[50-60)",
                   contact_permanence >= 60 & contact_permanence < 70 ~ "[60-70)",
                   contact_permanence >= 70 & contact_permanence < 80 ~ "[70-80)",
                   contact_permanence >= 80 & contact_permanence < 90 ~ "[80-90)",
                   contact_permanence >= 90 & contact_permanence < 100 ~ "[90-100)",
                   contact_permanence == 100 ~ "[100]" )) %>% 
  mutate(bin_permanence_factor2 = as.factor(contact_permanence_2))

fig1_final_visual_check_final_contact_info$bin_permanence_factor2 <- factor(fig1_final_visual_check_final_contact_info$bin_permanence_factor2, levels = c("[0]","[0-10)", "[10-20)","[20-30)",  "[30-40)", "[40-50)", "[50-60)", "[60-70)" , "[70-80)", "[80-90)" ,"[90-100)", "[100]"))
levels(as.factor(fig1_final_visual_check_final_contact_info$bin_permanence_factor2))
```


- Save fig1_final_visual_check_final_contact_info table
```{r saving-info-contact-df}
write.csv(x=fig1_final_visual_check_final_contact_info, file='../data/fig1_final_visual_check_final_contact_info.csv')

```


## Creation of a second contact information df

- in this df the column of permanency (robustness) is transversed and min,max,mean,mode of contacts. This 'transverse and gather table' is used for plot normalized evolutionary rate vs all contact category (min,max,mode,diff_max_min)

```{r gather-stats-on-contacts}
fig1_final_contact_info_gather<-fig1_final_visual_check_final_contact_info %>% 
  tidyr::gather(max_min_mode_category, max_min_mode_value, mean_contacts:diff_max_min)
```



- add a column factor of contacts groupingin fig1_final_contact_info_gather >= 7 contacts together
```{r factor-column-contact-gather-df}
fig1_final_contact_info_gather$max_min_mode_value_factor <-round(fig1_final_contact_info_gather$max_min_mode_value)
fig1_final_contact_info_gather$max_min_mode_value_factor <- factor(fig1_final_contact_info_gather$max_min_mode_value_factor)

contacts_to_group <-c(7,8,9,10,11,12,13,14)
for (i in contacts_to_group){
  levels(fig1_final_contact_info_gather$max_min_mode_value_factor)[levels(fig1_final_contact_info_gather$max_min_mode_value_factor)==i] <- ">=7"
}
```


So up-to now we have FIVE main df: 
- fig1_final_visual_check_final with all information by position by conformer
- fig1_final_visual_check_final_contact_info with all information about contact by ensemble
- fig1_final_contact_info_gather which has transverse column of category of contacts (this is the old smaller_gather)
- all rsmf --> rmsf data for ensemble
- disorder_category_df --> a df with categories of disorder (see python script for more details)
- corr_data --> df with data of correlations and boostrapping


# Plots 
## MAIN PLOTS
### Fig 1: comparison between rates of disorder and order positions in disoder dataset with a positive visual check

```{r plot-rates-dis-ord-positions, message= FALSE}
# Define stats comparison

compare_pairs <- list(c("disorder", "order"))
compare_pairs_labely <- c(5.2)

# Set size
png(res = 300, width = 7, height = 6, units = "in")
# Build plot

fig1_normperprot_visual_check <- fig1_final_visual_check_final_contact_info %>% 
  filter(dataset=='disorder') %>% 
  select(dataset, normperprot, structure) %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
  ggboxplot(x = "structure2", y = "normperprot", order = c("disorder", "order"),
                                           color = "structure2", fill = "structure2", 
                                           palette = c("#D7191c", "#2c7bb6"),
                                           shape = "structure2", alpha = 0.3, outlier.alpha = 0.1,
                                           xlab = " ", ylab = 'normalized evolutionary rate') +
            
  coord_cartesian(ylim = c(0,5.6)) +
  scale_y_continuous(breaks=c(0, 1, 2, 3, 4, 5), expand = c(0, 0))+
  #scale_x_continuous(expand = c(0, 0)) + 
  xlab('')+
  theme(legend.position="none") +
   theme(axis.line = element_line(colour = "black"),
    panel.grid.major = element_blank(),
    panel.grid.minor = element_blank(),
    panel.border = element_blank(),
    plot.background=element_blank())+
  theme(panel.grid.major.y = element_blank(),
        panel.grid.major.x = element_blank())+
  theme( axis.title.x = element_text(face='plain', size=15),
         axis.ticks.x=element_blank(),
         axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)))+
  theme(axis.text=element_text(size=15))+
  stat_compare_means(comparisons = compare_pairs, label = "p.signif", label.x = 1.3, label.y = compare_pairs_labely, method = "wilcox.test", size = 6)
# Make plot
ggsave("../figures/fig1/fig1.png", plot = fig1_normperprot_visual_check)
dev.off()
fig1_normperprot_visual_check+labs(x = NULL)
```
### Stadistics on number of contacts
```{r stadistics-regarding-fig-1}
# main text 
fig1_final_visual_check_final %>% 
  filter(dataset=='disorder') %>% 
  select(structure2,contacts) %>% 
  group_by(structure2) %>% 
  summarise(mean(contacts))

# caption
fig1_final_visual_check_final %>% 
  filter(dataset=='disorder') %>% 
  select(structure2,normperprot) %>% 
  group_by(structure2) %>% 
  summarise(median(normperprot))

# length and conformers
fig1_final_visual_check_final_contact_info %>% 
  filter(dataset=='disorder') %>% 
  select(protein_length,number_conf,pdb_chain) %>% 
  summarise(max(number_conf), min(number_conf), mean(number_conf), max(protein_length), min(protein_length))
  
```

### Fig2: Profiles figures
- Panel A
```{r fig2_panel_a, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
dis_or <- c('2cqrA','2k3aA','2khmA','2myxA','2rsmA','2rsoA','2rvlA')
fig2_panel_a<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% dis_or) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '<b>A</b> disorder-order<br>', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% dis_or) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 9, height = 4, units = "in")
# Make plot
ggsave("../figures/fig2/fig2_panel_a.png", plot = fig2_panel_a)
dev.off()
fig2_panel_a
```


- Panel B
```{r fig2_panel_b, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
or_dis <- c('1uffA','1ug1A', '1jvrA','2hmxA' ,'2k4kA','2k5fA','2ru8A')
fig2_panel_b<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% or_dis) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '<b>B</b> order-disorder<br>', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% or_dis) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 9, height = 4, units = "in")
# Make plot
ggsave("../figures/fig2/fig2_panel_b.png", plot = fig2_panel_b)
dev.off()
fig2_panel_b
```

- Panel C
```{r fig2_panel_c, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
dis_or_dis <- c('1u6fA','1wj7A','1ixdA','2dh7A','2ecbA','2ejmA','2k8pA')
fig2_panel_c<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% dis_or_dis) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '<b>C</b> disorder-order-disorder<br>', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% dis_or_dis) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 9, height = 4, units = "in")
# Make plot
ggsave("../figures/fig2/fig2_panel_c.png", plot = fig2_panel_c)
dev.off()
fig2_panel_c
```

- Panel D
```{r fig2_panel_d, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
or_dis_or <- c('2mphA','2l3sA','1qu6A','2lbcA', '2adzA') 
fig2_panel_d<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% or_dis_or) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '<b>D</b> order-disorder-order <br>', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% or_dis_or) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 9, height = 4, units = "in")
# Make plot
ggsave("../figures/fig2/fig2_panel_d.png", plot = fig2_panel_d)
dev.off()
fig2_panel_d
```

- Panel E
```{r fig2_panel_e, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
crazy_little_things <- c('1mm4A','1sm7A','1tteA','1vzsA','2aivA','2afjA','2n1rA')
fig2_panel_e<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% crazy_little_things) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '<b>E</b> complex<br>', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% crazy_little_things) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=8),
                  axis.title.y = element_text(face='plain',size=8))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 9, height = 4, units = "in")
# Make plot
ggsave("../figures/fig2/fig2_panel_e.png", plot = fig2_panel_e)
dev.off()
fig2_panel_e
```


```{r fig2_all_panels, message=FALSE, warning=FALSE}
png(res = 300, width = 9, height = 15, units = "in","../figures/fig2/fig2_all_panels.png")
multiplot(fig2_panel_a,fig2_panel_b,fig2_panel_c, fig2_panel_d, fig2_panel_e,cols = 1)
dev.off()
```

### Fig 3
```{r fig3, message=FALSE, warning=FALSE}
compare_pairs <- list(c("disorder", "order"))
compare_pairs_labely <- c(5, 5, 5, 5, 5, 4.5, 4.4, 4)

fig3 <- fig1_final_contact_info_gather %>%  
          filter(dataset=='disorder') %>% 
          filter(max_min_mode_category=='mean_contacts') %>% 
          mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
    ggboxplot(x = "max_min_mode_value_factor", y = "normperprot",
            color='structure2', 
            fill ='structure2',
             palette = c("#D7191c","#2c7bb6"),
            shape = "structure2", alpha = 0.3, outlier.alpha = 0.1, 
            xlab = "contact average", ylab = 'normalized evolutionary rate',
            title = '')+
    theme(legend.position = c(0.9,0.95), legend.title = element_blank())+
    theme(panel.grid.major.x = element_blank(), 
        panel.grid.major.y = element_blank(),
        plot.background=element_blank(), 
        panel.border = element_blank())+
    theme(axis.ticks.x=element_blank(),
        axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
        axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
        axis.text=element_text(size=10), 
        title = element_text(face='bold'))+
  scale_y_continuous(expand = c(0,0), limits = c(0,5.5), breaks=c(0, 1, 2, 3, 4, 5))+
    stat_compare_means(aes(group = structure2), label = "p.signif", label.x = 1.3, label.y = compare_pairs_labely, method = "wilcox.test", size = 3)

fig3

# Set size
png(res = 300, width = 9, height = 6, units = "in")

# Make plot
ggsave("../figures/fig3.png", plot = fig3)
dev.off()
```

### Fig 4

```{r fig4-rate-mean-contacts-vs-distance-from-order, message=FALSE, warning=FALSE, fig.dim = c(9, 12)}
# Set size
png(res = 300, width = 9, height = 12, units = "in")

# A: Plot rate vs distance 
fig4_rate<-fig1_final_visual_check_final_contact_info %>% 
  left_join(distance_from_order_df) %>% 
  filter(dataset=='disorder') %>% 
  filter(distance_from_order != 'NA') %>% 
  filter(distance_from_order <= 30) %>% 
  mutate(distance_from_order_factor3 = as.factor(distance_from_order)) %>% 
  ggplot(aes(x=distance_from_order_factor3, y = normperprot,fill=structure2, color=structure2))+
  geom_boxplot(alpha = 0.3, outlier.alpha = 0.1)+
  
  labs(x='distance from order', y='normalized evolutionary rate', title = 'A')+
  scale_x_discrete(breaks=seq(0,40,5))+
  scale_y_continuous(expand = c(0,0), breaks = seq(0,5,1), limits = c(0,5) )+
  scale_fill_manual( values = c("#D7191c", "#2c7bb6"))+
  scale_color_manual( values = c("#D7191c", "#2c7bb6"))+
  
  
  theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = c(0.9, 0.95),
      legend.title = element_blank())+
  
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=13))
#fig3_rate

# B: Plot rate vs avg contacts 
fig4_mean_contacts<-fig1_final_visual_check_final_contact_info %>% 
  left_join(distance_from_order_df) %>% 
  filter(dataset=='disorder') %>% 
  filter(distance_from_order != 'NA') %>% 
  filter(distance_from_order <= 30) %>% 
  mutate(distance_from_order_factor3 = as.factor(distance_from_order)) %>% 
  ggplot(aes(x=distance_from_order_factor3, y = mean_contacts,fill=structure2, color=structure2))+
  geom_boxplot(alpha = 0.3, outlier.alpha = 0.1)+
  
  labs(x='distance from order', y='contact average', title = 'B')+
  scale_x_discrete(breaks=seq(0,40,5))+
  scale_y_continuous(expand = c(0,0), breaks = seq(0,13,1), limits = c(0,13) )+
  scale_fill_manual( values = c("#D7191c", "#2c7bb6"))+
  scale_color_manual( values = c("#D7191c", "#2c7bb6"))+
  
  
  theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = '',
      legend.title = element_blank())+
  
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=13))

#fig3_mean_contacts

fig4<-(fig4_rate/fig4_mean_contacts)
# Make plot
ggsave("../figures/fig4.png", plot = fig4)
dev.off()
fig4
```

```{r}
fig1_final_visual_check_final_contact_info %>% 
  left_join(distance_from_order_df) %>% 
  filter(dataset=='disorder') %>% 
  filter(distance_from_order != 'NA') %>% 
  filter(structure2 == 'disorder') %>% 
  summarise(mean(distance_from_order), max(distance_from_order))
```







### Fig 5
- conformers needed to obtain the best correlation with normalized rate
```{r fig5, message=FALSE, warning=FALSE}
# set size
png(res = 300, width = 9, height = 6, units = "in")

#make plot 
fig5 <- corr_data %>% 
  filter(best_combination == 'corrfrac' | best_combination == 'corrave') %>% 
    mutate(number_of_conformers=ifelse(best_combination=='corrfrac',conffrac,confave)) %>% 
    mutate(best_combination2=ifelse(best_combination=='corrfrac','contact robustness', 'contact average')) %>% 
     mutate(number_of_conformers_factor = as.factor(number_of_conformers)) %>% 
   select( best_combination, best_combination2, number_of_conformers, number_of_conformers_factor) %>% 
    count(best_combination, best_combination2, number_of_conformers, number_of_conformers_factor) %>% 
    complete(best_combination, best_combination2, number_of_conformers, number_of_conformers_factor) %>% 
  #plot 
    ggplot(aes(x = number_of_conformers_factor, y = n, fill = best_combination2, 
               color = best_combination2)) +
    geom_bar(position="dodge", stat="identity", width = 0.7, col="white", na.rm = TRUE) +
    ylab('frequency')+xlab('number of confomers')+
    scale_fill_grey()+
    scale_color_grey()+
    scale_y_continuous(expand = c(0,0), breaks = seq(0, 60, by = 5))+
    theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = c(0.8, 0.9),
      legend.title = element_blank())+
  
    theme(axis.ticks.x=element_blank(),
          axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=13))
# Make plot
ggsave("../figures/fig5.png", plot = fig5)
dev.off()
fig5
```



```{r stadistics-on-fig5}
corr_data %>% 
  filter(best_combination == 'corrfrac' | best_combination == 'corrave') %>% 
    mutate(number_of_conformers=ifelse(best_combination=='corrfrac',conffrac,confave)) %>% 
    mutate(best_combination2=ifelse(best_combination=='corrfrac','contact robustness', 'contact average')) %>% 
  group_by(best_combination) %>% 
  summarise(mean(number_of_conformers), mean(rmsd_max), mean(rmsd_mean), max(rmsd_mean))
```


## Sup Figures

### S1
- different contact ensemble descriptor (min, max, mode) vs normalized rate
```{r figS1, message=FALSE, warning=FALSE}
compare_pairs <- list(c("disorder", "order"))
compare_pairs_labely <- c(4.5, 4.5, 5, 4.5, 5, 4.5, 4.4, 4)

figS1_max <- fig1_final_contact_info_gather %>%  
  filter(max_min_mode_category == 'max_contacts') %>% 
  filter(dataset=='disorder') %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
  ggboxplot(x = "max_min_mode_value_factor", y = "normperprot",
            color='structure2', 
            fill ='structure2',
             palette = c("#D7191c","#2c7bb6"),
            shape = "structure2", alpha = 0.3, outlier.alpha = 0.1, 
            xlab = "maximum number of contacts", ylab = 'normalized evolutionary rate')+
  theme(legend.position = '')+
  theme(panel.grid.major.x = element_blank(), 
        panel.grid.major.y = element_blank(),
        plot.background=element_blank(), 
        panel.border = element_blank())+
  theme(axis.title.x = element_text(face='plain', size=10),
        axis.title.y = element_text(face='plain',size=10),
        axis.text=element_text(size=10), 
        title = element_text(face='bold'))+
      stat_compare_means(aes(group = structure2), label = "p.signif", label.x = 1.3, label.y = compare_pairs_labely, method = "wilcox.test", size = 3)
figS1_max

compare_pairs_labely <- c(5, 5, 4.8, 4.5, 4.3, 4, 3.8, 4)
figS1_min <- fig1_final_contact_info_gather %>%  
  filter(max_min_mode_category == 'min_contacts') %>% 
  filter(dataset=='disorder') %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
  ggboxplot(x = "max_min_mode_value_factor", y = "normperprot",
            color='structure2', 
            fill ='structure2',
             palette = c("#D7191c","#2c7bb6"),
            shape = "structure2", alpha = 0.3, outlier.alpha = 0.1, 
            xlab = "minimum number of contacts", ylab = '')+
    theme(legend.position = '')+
    theme(panel.grid.major.x = element_blank(), 
        panel.grid.major.y = element_blank(),
        plot.background=element_blank(), 
        panel.border = element_blank())+
  theme(axis.title.x = element_text(face='plain', size=10),
        axis.text=element_text(size=10), 
        title = element_text(face='bold'))+
        stat_compare_means(aes(group = structure2), label = "p.signif", label.x = 1.3, label.y = compare_pairs_labely, method = "wilcox.test", size = 3)
figS1_min

figS1_mode <- fig1_final_contact_info_gather %>%  
  filter(max_min_mode_category == 'mode_contacts') %>% 
  filter(dataset=='disorder') %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
  ggboxplot(x = "max_min_mode_value_factor", y = "normperprot",
            color='structure2', 
            fill ='structure2',
             palette = c("#D7191c","#2c7bb6"),
            shape = "structure2", alpha = 0.3, outlier.alpha = 0.1, 
            xlab = "contacts mode", ylab = '')+
    theme(legend.position = c(0.8,0.95), legend.title = element_blank())+
    theme(panel.grid.major.x = element_blank(), 
        panel.grid.major.y = element_blank(),
        plot.background=element_blank(), 
        panel.border = element_blank())+
  theme(axis.title.x = element_text(face='plain', size=10),
        axis.text=element_text(size=10), 
        title = element_text(face='bold'))+
        stat_compare_means(aes(group = structure2), label = "p.signif", label.x = 1.3, label.y = compare_pairs_labely, method = "wilcox.test", size = 3)
figS1_mode

# Set size
png(res = 300, width = 12, height = 6, units = "in")
figS1 <- (figS1_max + figS1_min + figS1_mode)
# Make plot
ggsave("../figures/figS1.png", plot = figS1)
dev.off()
```

### S2
- distribution of contact robustness for order and disorder positions
```{r figS2, echo=TRUE, message=FALSE, warning=FALSE, paged.print=FALSE}
figS2 <- fig1_final_visual_check_final_contact_info %>% 
  filter(dataset == 'disorder') %>% 
  ggplot( aes(x = contact_permanence, fill = structure2, color = structure2)) +
  geom_density(alpha=0.3)+
  scale_fill_manual(values=c("#D7191c","#2c7bb6"))+
  scale_color_manual(values=c("#D7191c","#2c7bb6"))+
  ylab('frequency') + xlab('contact robustness')+
  scale_x_continuous(breaks = seq(0,100,25), expand = c(0,0)) + 
  scale_y_continuous(expand = c(0, 0))+
    theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = c(0.85, 0.85),
      legend.title = element_blank())+
  
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=13),
          plot.margin = unit(c(0.5,0.5,0.1,0.1),'cm'))
figS2

# Set size
png(res = 300, width = 9, height = 6, units = "in")
# Make plot
ggsave("../figures/figS2.png", plot = figS2)
dev.off()
```

### S3
```{r figS3}
compare_pairs <- list(c("[0]","[100]"), c("[0]", "[0-10)"), c("[0-10)", "[10-20)"), 
                      c( "[10-20)","[20-30)"), c("[20-30)","[30-40)"),
                      c("[30-40)", "[40-50)"), c("[40-50)","[50-60)" ), 
                      c("[50-60)", "[60-70)"), c("[60-70)", "[70-80)"),
                      c("[70-80)", "[80-90)"), c("[80-90)","[90-100)"),
                      c("[90-100)","[100]"))
compare_pairs_labely <- c(5.2,4.8,4.8,4.8,4.8,4.8,4.8,4.8,4.8,4.8,4.8,4.8)

figS3 <- fig1_final_visual_check_final_contact_info %>%  
  filter(dataset=='disorder') %>% 
  filter(bin_permanence_factor != 'NA') %>% 
  mutate(structure2=ifelse(structure=='disorder(dis)','disorder','order')) %>% 
  select(bin_permanence_factor2,normperprot, structure2) %>% 
  filter(structure2 == 'disorder') %>% 
  distinct() %>% 
      ggboxplot(x = "bin_permanence_factor2", y = "normperprot",
            color='structure2', 
            fill ='structure2',
             palette = c("#D7191c"),
            shape = "structure2", alpha = 0.3, outlier.alpha = 0.1, 
            xlab = "contact robustness", ylab = 'normalized evolutionary rate', 
            title = ' ')+
  theme(legend.position = ' ', legend.title = element_blank())+
    theme(panel.grid.major.x = element_blank(), 
        panel.grid.major.y = element_blank(),
        plot.background=element_blank(), 
        panel.border = element_blank())+
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
        axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
        axis.text=element_text(size=10), 
        title = element_text(face='bold'))+
  scale_y_continuous(expand = c(0,0), limits = c(0,5.6), breaks=c(0, 1, 2, 3, 4, 5))+
   stat_compare_means(label = "p.signif", comparisons = compare_pairs, label.x = 1.5, label.y = compare_pairs_labely, method = "wilcox.test", size = 3)

# Set size
png(res = 300, width = 9, height = 6, units = "in")
# Make plot
ggsave("../figures/figS3.png", plot = figS3)
dev.off()
figS3
```


###S4
```{r figS4-rmsf-vs-distance-from-order, message=FALSE, warning=FALSE, paged.print=FALSE}
# Plot normalized rmsf vs distance 
figS4<-fig1_final_visual_check_final_contact_info %>% 
  left_join(distance_from_order_df) %>% 
  filter(dataset=='disorder') %>% 
  filter(distance_from_order != 'NA') %>% 
  filter(distance_from_order <= 30) %>% 
  mutate(distance_from_order_factor3 = as.factor(distance_from_order)) %>% 
  ggplot(aes(x=distance_from_order_factor3, y = rmsf_norm,fill=structure2, color=structure2))+
  geom_boxplot(alpha = 0.3, outlier.alpha = 0.1)+
  
  labs(x='distance from order', y='normalized RMSF', title = '')+
  scale_x_discrete(breaks=seq(0,40,5))+
  scale_y_continuous(expand = c(0,0), breaks = seq(0,14,1), limits = c(0,14) )+
  scale_fill_manual( values = c("#D7191c", "#2c7bb6"))+
  scale_color_manual( values = c("#D7191c", "#2c7bb6"))+
  
  
  theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = c(0.9, 0.95),
      legend.title = element_blank())+
  
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=13))
# Set size
png(res = 300, width = 9, height = 6, units = "in")
# Make plot
ggsave("../figures/figS4.png", plot = figS4)
dev.off()

figS4
```

### S5
```{r figS5-tables}
disorder_info <- fig1_final_visual_check_final %>% 
  select(pdb_chain,position,is_disorder_es,structure2) %>% 
  unique()

number_conf_df <- fig1_final_visual_check_final_contact_info %>% 
  select(pdb_chain, number_conf) %>% 
  unique()

contact_matrix <- contact_matrix %>% 
  left_join(disorder_info, by = c("pdb_chain" = "pdb_chain", "second_position" = "position")) %>%
  mutate(second_pos_is_disorder=is_disorder_es) %>% 
  mutate(second_pos_structure2 = structure2) %>% 
  select(-is_disorder_es,-structure2) %>% 
  mutate(type_contact = ifelse(second_pos_structure2=='disorder','to_disorder','to_order')) %>% 
  left_join(disorder_info, by = c("pdb_chain" = "pdb_chain", "position" = "position")) %>% 
  mutate(first_pos_is_disorder=is_disorder_es) %>% 
  mutate(first_pos_structure2=structure2) %>%  
  select(-is_disorder_es,-structure2) %>% 
  mutate(distance_between_pos=abs(position-second_position)) %>% 
  left_join(number_conf_df)

contact_matrix <- contact_matrix %>% 
  select(-second_position, -second_pos_is_disorder, -second_pos_structure2, -distance_between_pos) %>% 
  group_by(pdb_chain, model, position, type_contact) %>% 
  mutate(total_contact_type_model= sum(is_contact)) %>% 
  ungroup() %>% 
  group_by(pdb_chain, model, position) %>% 
  mutate(total_contacts_model = sum(is_contact)) %>% 
  mutate(percent_type_contact_model = total_contact_type_model/total_contacts_model) %>% 
  left_join(distance_from_order_df) %>% 
  mutate(distance_from_order_factor3 = factor(distance_from_order, levels = c(0:100))) %>% 
  distinct()

contact_matrix_ensemble <- contact_matrix %>% 
  group_by(pdb_chain,position, type_contact) %>% 
  mutate(total_contact_type_ensemble=sum(total_contact_type_model)) %>% 
  mutate(mean_percent_contact_type=mean(percent_type_contact_model)) %>% 
  select( -model, -total_contact_type_model, -total_contacts_model, -percent_type_contact_model) %>% 
  distinct()

contact_matrix_ensemble <- contact_matrix_ensemble %>% 
  spread(key = type_contact, value = mean_percent_contact_type) %>% 
  mutate(to_order = if_else(is.na(to_order), 1-to_disorder,to_order)) %>% 
  mutate(to_disorder = if_else(is.na(to_disorder), 1-to_order,to_disorder)) %>% 
  select(-total_contact_type_ensemble) %>% 
  tidyr::gather(key=type_contact, value=mean_percent_contact_type, to_disorder, to_order) %>% 
  distinct()

rm(disorder_info, number_conf_df, contact_matrix)

```

```{r figS5}
figS5 <- contact_matrix_ensemble %>% 
  filter(type_contact != 'NA') %>% 
  filter(first_pos_structure2 != 'NA') %>% 
  filter(distance_from_order <= 30) %>% 
  ggplot(aes(x=distance_from_order_factor3, y = mean_percent_contact_type,fill=first_pos_structure2, color=first_pos_structure2))+
  geom_boxplot(alpha = 0.3, outlier.alpha = 0.1)+
  facet_grid(rows=vars(type_contact))+
  labs(x='distance from order', y='proportion of contacts', title = '')+
  scale_x_discrete(breaks=seq(0,40,5))+
  #scale_y_continuous(expand = c(0,0), breaks = seq(0,10,5), limits = c(0,20) )+
  scale_fill_manual( values = c("#D7191c", "#2c7bb6"))+
  scale_color_manual( values = c("#D7191c", "#2c7bb6"))+
  
  
  theme(axis.line = element_line(size = 0.6, 
      linetype = "solid"), panel.grid.major = element_line(linetype = "blank"), 
      panel.grid.minor = element_line(linetype = "blank"), 
      panel.background = element_rect(fill = NA), 
      plot.background = element_rect(linetype = "solid"), 
      legend.position = " ",
      legend.title = element_blank())+
  
    theme(axis.title.x = element_text(face='plain', size=15, margin = margin(t = 8, r = 0, b = 0, l = 0)),
          axis.title.y = element_text(face='plain',size=15, margin = margin(t = 0, r = 8, b = 0, l = 0)),
          axis.text=element_text(size=10), 
          title = element_text(face='bold'), 
          legend.text=element_text(size=8))
# Set size
png(res = 300, width = 9, height = 6, units = "in")
# Make plot
ggsave("../figures/figS5.png", plot = figS5)
dev.off()
figS5
```





#Graphical abstract

```{r graphical_abstrac_panel_c, message=FALSE, warning=FALSE, fig.dim = c(9, 4)}
dis_or_dis <- c('1u6fA','1wj7A','1ixdA','2dh7A','2ecbA','2ejmA','2k8pA')
graphical_abstrac_panel_c<-fig1_final_visual_check_final_contact_info %>% 
  filter(pdb_chain %in% dis_or_dis) %>% 
  ggplot(mapping = aes(x=position_length_sig2, y=normperprot)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,4))+
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(title = '', 
               x = 'normalized position', y= 'normalized evolutionary rate') +
  
          theme(plot.title = element_textbox_simple(size = 13,lineheight = 1,
                  padding = margin(0, 0, 0, 0),margin = margin(0, 10, -7, -11)),
                  legend.position=" ", legend.title = element_blank())+
  
          theme( axis.title.x = element_text(face='plain', size=15),
                  axis.title.y = element_text(face='plain',size=15))+
  
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(0,0.3,0,0), "cm"),
                plot.background = element_rect(linetype = "solid"))+
            
          
  { #--------------------------------------------------------------------------*
    # RMSF Plot
    fig1_final_visual_check_final_contact_info %>% 
    filter(pdb_chain %in% dis_or_dis) %>% 
      ggplot(mapping = aes(x=position_length_sig2, y=rmsf_norm)) +
          geom_line(aes(color=pdb_chain))+
          geom_smooth(method = "loess", color='#0041C2', fill='#87AFC7', alpha=0.7)+
          scale_color_grey()+
          coord_cartesian(ylim = c(0,7.5)) +
          scale_x_continuous(expand = c(0, 0)) + 
          scale_y_continuous(expand = c(0, 0))+
          labs(y = 'normalized RMSF', x= 'normalized position') +
      
          theme(legend.position=" ", legend.title = element_blank())+
          
          theme( axis.title.x = element_text(face='plain', size=15),
                  axis.title.y = element_text(face='plain',size=15))+
      
          theme(axis.line = element_line(size = 0.6, linetype = "solid",  color= '#4c4c4c'),
                panel.grid.major = element_line(linetype = "blank"), 
                panel.grid.minor = element_line(linetype = "blank"), 
                panel.background = element_rect(fill = NA), 
                plot.margin = unit(c(-5,0.3,-5,0.25), "cm"),
                plot.background = element_rect(linetype = "solid"))
  }+
  patchwork::plot_layout(ncol = 3, widths = c(3, 3))
# Set size
png(res = 300, width = 15, height = 6, units = "in")
# Make plot
ggsave("../figures/graph-abstract/graphical_abstrac_panel_c.png", plot = graphical_abstrac_panel_c)
dev.off()
graphical_abstrac_panel_c
```


